#!/usr/bin/perl
#	logview - a unix log file viewer
#	initially written by Alex Soldatoff (alx@centrobank.e-burg.ru),
#	rewritten by Eugene Borodin (eug@centrobank.e-burg.ru) with
#		support for 'live tail mode', acl's and config options.
#
#	v 0.76.2
#
#	This is free software.
#
#
require './logviewer-lib.pl';
%access=&get_module_acl();

# defaults
$tail = '/usr/bin/tail -f';
@sz  = ($text{'index_sz1'}, $text{'index_sz2'});
@sufText = ($text{'index_stxt1'}, $text{'index_stxt2'});
@suf     = ("",               ".0");

$in{'logSuf'} = "";
$in{'LOG'}    = "/var/adm/messages";
$logI         = 0;
$szI          = 0;
$meta_http="<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$config{'refresh_interval'}, URL=/$module_name\">";
# ---------

&ReadParse();
$|=1;
$tail=$config{'live_tail_cmd'} if defined $config{'live_tail_cmd'};
@logs=();
@llist=split /\s+/, $config{'logs'};
@alist=split /\s+/, $access{'allowed_logs'};
if($access{'allowed_logs'} ne "*") {
	foreach $log (@llist) {
        	foreach $allowed (@alist) {
                	push @logs, $log if $log eq $allowed;
                	}
        	}
	}
else {
	foreach $log (@llist) {
		push @logs, $log;
		}
	}
if(++$#logs == 0 ) { 
	push @logs,$text{'index_nothing'};
	}

$sufI = $in{'sufI'};
$logI = $in{'logI'};
$LOG  = "$logs[$logI]$suf[$sufI]";
$szI  = $in{'szI'};
$SZ   = $sz[szI];
#------------------------------------------------------------ 
&header("$text{'index_title'} $LOG", "", "intro", 1, 1, undef, 
	"<a name=start href=#end>$text{'index_gobott'}</a>",
	$config{'live_tail_mode'} ? 
		"" : 
		$config{'refresh_interval'} ? 
			$meta_http : 
			"" );

print <<EOM; 
<hr>
<form action=\"#end\">

$text{'index_menufile'}  
<select name=logI>
EOM
for($i=0; $i <= $#logs; $i++) { 
	print "\t<option value=\"$i\" ",
		$logI == $i ? "selected" : "",
		" >$logs[$i]\n";
	}
print "</select>\n";

print <<EOM;
$text{'index_menufrom'}
<select name=sufI>
EOM
for($i=0; $i <= $#suf; $i++) { 
	print "\t<option value=\"$i\" ",
		$sufI == $i ? "selected" : "",
		" >$sufText[$i]\n";
	}
print "</select>\n";

print <<EOM; 
$text{'index_menurecords'}
<select name=szI>
EOM
for($i=0; $i <= $#sz; $i++) { 
	print "\t<option value=\"$i\" ",
		$szI == $i ? "selected" : "",
		" >$sz[$i]\n";
	}
print "</select>\n";

print <<EOM;
<input type=submit value=\"$text{'index_showbutton'}\">

</form>
<hr>\n
EOM
#<a type=buttom href=\"#end\">Goto End</a>

if($config{'live_tail_mode'}) {
	# lets do some tricks for controlling 
	# a non obedient children:
        # forking for tail
        if (not  defined($tail_cpid=open(LOG,"-|"))) {
                die "Can't fork for tail\n";
        	} 
	elsif ($tail_cpid) {
                # parent
	        # forking again, for killer
       		if (not  defined($killer_cpid=fork())) {
        		die "Can't fork for killer\n";
        		} 
		elsif ($killer_cpid) {
                	# parent
                	# do display records 
                	goto DISPLAY;
        		} 
		else {
                	# child - killer (kills his brother tail)
			sleep $config{'live_tail_ttl'}*60;
			kill 15, $tail_cpid or 
				kill 9, $tail_cpid or
					die "Killer can't kill tail\n";
			exit 0;
			} # fork killer
        	} 
	else {
                # child
		$|=1;
		exec ("$tail $LOG") or 
			&error("$text{'index_erropen'} $LOG: $!\n");
		} # fork tail
	}
else {
	open LOG,$LOG or 
		&error("$text{'index_erropen'} $LOG: $!\n");
	# for Last (records) option
	if ( $szI == 0 ) { 
		seek LOG, -$config{'last_bytes_to_display'}, 2; 
		<LOG>; # Skip uncompleted line
		}
	} # if live mode 

DISPLAY:
print "\n<pre>\n";
while(<LOG>) {
	s/</&lt;/g; 
	s/>/&gt;/g;
	print;
	}
print "\n</pre>\n";

print <<EOM;
<a name=\"end\"></a>
<hr>
<div align=right>
<a href=\"#start\">$text{'index_gotop'}</a>
</div>
<hr>
EOM

&footer("/", $text{'index_return'});
